<?php
//  
class udoc
{
    var $db;
    var $udoc_tree;
    var $a_params;
    var $lang_id;
    var $lang_name;
    var $table;
    var $res;

    function udoc(&$db, &$a_params, $lang_id = null)
    {
        $this->db = &$db;
        $this->a_params = &$a_params;
        $this->lang_id = $lang_id;
    }

    // 
    function getTree($table, $id)
    {
        $res = $this->db->Execute("SELECT * FROM ".$table." WHERE ".$table."_id=".$id);

        if ($res->RecordCount()>0)
        {
            $elements = $res->FetchArray();
        }
        if ($elements[$table."_parent"]!=0)
        {
            $this->object_tree[$table."_id"][]=$elements[$table."_id"];
            $this->object_tree[$table."_name"][]=$elements[$table."_name"];
            $this->object_tree[$table."_parent"][]=$elements[$table."_parent"];
            $this->object_tree["category_id"][]=$elements["category_id"];
            $this->object_tree["view_id"][]=$elements["view_id"];
            $this->object_tree[$table."_filename"][]=$elements[$table."_filename"];
            $this->object_tree[$table."_picture_icon"][]=$elements[$table."_picture_icon"];
            $this->object_tree[$table."_picture_banner"][]=$elements[$table."_picture_banner"];
            $this->object_tree[$table."_picture_background"][]=$elements[$table."_picture_background"];
            return $this->getTree($table, $elements[$table."_parent"]);
        }
        else
        {
            $this->object_tree[$table."_id"][]=$elements[$table."_id"];
            $this->object_tree[$table."_name"][]=$elements[$table."_name"];
            $this->object_tree[$table."_parent"][]=$elements[$table."_parent"];
            $this->object_tree["category_id"][]=$elements["category_id"];
            $this->object_tree["view_id"][]=$elements["view_id"];
            $this->object_tree[$table."_filename"][]=$elements[$table."_filename"];
            $this->object_tree[$table."_picture_icon"][]=$elements[$table."_picture_icon"];
            $this->object_tree[$table."_picture_banner"][]=$elements[$table."_picture_banner"];
            $this->object_tree[$table."_picture_background"][]=$elements[$table."_picture_background"];
            return $elements["category_id"];
        }
    }

    // udoc  category_id
    function getUdoc($category_id, $sorting = "ORDER BY udoc_sort")
    {
        $mass_element=array();
        if ($category_id=="") return 0;

        $res = $this->db->Execute("SELECT * FROM udoc WHERE category_id=".$category_id." AND (udoc_visible=1 OR udoc_visible=2) ".$sorting);

        if ($res->RecordCount()>0)
        {
            while ($element = $res->FetchArray())
            {
                $mass_element["udoc_id"][]=$element["udoc_id"];
                $mass_element["udoc_parent"][]=$element["udoc_parent"];
                $mass_element["udoc_name"][]=$element["udoc_name"];
                $mass_element["view_id"][]=$element["view_id"];
                $mass_element["udoc_filename"][]=$element["udoc_filename"];
                $mass_element["udoc_date"][]=$element["udoc_date"];
            }
        }

        return $mass_element;
    }

    //   udoc_parent
    function getUdocParent($udoc_parent)
    {
        $mass_element=array();
        if ($udoc_parent=="") return 0;

        $res = $this->db->Execute("SELECT * FROM udoc WHERE udoc_parent=".$udoc_parent." AND (udoc_visible=1 OR udoc_visible=2) ORDER BY udoc_sort");

        if ($res->RecordCount()>0)
        {
            while ($element = $res->FetchArray())
            {
                $mass_element["udoc_id"][]=$element["udoc_id"];
                $mass_element["udoc_parent"][]=$element["udoc_parent"];
                $mass_element["udoc_name"][]=$element["udoc_name"];
                $mass_element["view_id"][]=$element["view_id"];
            }
        }

        return $mass_element;
    }

    //  
    function getUdocName($id, $lang=null)
    {
        if ($id<=0) return 0;

        //   
        $lang_where="";
        
        if ($lang!=null) 
        {
        	$lang_where="AND (udoc_name.lang_id=".$lang." OR udoc_name.lang_id=0)";
        }
        else
        {
        	if ($this->lang_id > 0) $lang_where="AND (udoc_name.lang_id=".$this->lang_id." OR udoc_name.lang_id=0)";
        }

        $mass_element=array();
        $res = $this->db->Execute("SELECT
        udoc.udoc_id,
        udoc.category_id,
        udoc_name.udoc_name_id,
        udoc.udoc_picture_icon,
        udoc.udoc_picture_banner,
        udoc.udoc_date,
        udoc.udoc_status,
        udoc_name.udoc_name_name,
        udoc_name.udoc_name_description,
        udoc_name.udoc_name_picture,
        udoc_name.udoc_name_title,
        udoc_name.udoc_name_keywords,
        udoc_name.udoc_name_descriptions,
        udoc_name.udoc_name_sort ".
        "FROM udoc LEFT JOIN udoc_name ON udoc.udoc_id=udoc_name.udoc_id ".
        "WHERE udoc.udoc_id=".$id." AND udoc.udoc_visible=1 ".$lang_where." ORDER BY udoc_name.udoc_name_sort");

        if ($res->RecordCount()>0)
        {
            while ($element = $res->FetchArray())
            {
                $mass_element["udoc_id"][]=$element["udoc_id"];
                $mass_element["category_id"][]=$element["category_id"];
                $mass_element["udoc_status"][]=$element["udoc_status"];
                $mass_element["udoc_name_id"][]=$element["udoc_name_id"];
                $mass_element["udoc_picture_icon"][]=$element["udoc_picture_icon"];
                $mass_element["udoc_picture_banner"][]=$element["udoc_picture_banner"];

                if (($element["udoc_date"]!="0000-00-00") AND ($element["udoc_date"]!=""))
                {
                    $mass_element["udoc_date"][]=date('d.m.Y', $this->str2time($element["udoc_date"], 'Y-m-d'));
                    $mass_element["udoc_day"][]=date('d', $this->str2time($element["udoc_date"], 'Y-m-d'));
                    $mass_element["udoc_moon"][]=date('m', $this->str2time($element["udoc_date"], 'Y-m-d'));
                    $mass_element["udoc_year"][]=date('Y', $this->str2time($element["udoc_date"], 'Y-m-d'));
                }
                else
                {
                    $mass_element["udoc_date"][]=null;
                    $mass_element["udoc_day"][]=null;
                    $mass_element["udoc_moon"][]=null;
                    $mass_element["udoc_year"][]=null;
                }

                $mass_element["udoc_name_name"][]=$element["udoc_name_name"];
                $mass_element["udoc_name_description"][]=$element["udoc_name_description"];
                $mass_element["udoc_name_picture"][]=$element["udoc_name_picture"];
                $mass_element["udoc_name_title"][]=$element["udoc_name_title"];
                $mass_element["udoc_name_keywords"][]=$element["udoc_name_keywords"];
                $mass_element["udoc_name_descriptions"][]=$element["udoc_name_descriptions"];
                $mass_element["udoc_name_sort"][]=$element["udoc_name_sort"];
            }
        }

        return $mass_element;
    }

    //  
    function getUdocNameCategory($id, $sort = null)
    {
        if ($id<=0) return 0;
        if ($sort==null) $sort=" ORDER BY udoc.udoc_sort";
        //   
        $lang_where="";
        if ($this->lang_id > 0) $lang_where="AND (udoc_name.lang_id=".$this->lang_id.")";

        $mass_element=array();
        $res = $this->db->Execute("SELECT
        udoc.udoc_id,
        udoc.udoc_name,
        udoc.udoc_date,
        udoc.udoc_status,
        udoc.udoc_picture_icon,
        udoc.udoc_picture_banner,
        udoc_name.udoc_name_id,
        udoc_name.udoc_name_name,
        udoc_name.udoc_name_description,
        udoc_name.udoc_name_picture,
        udoc_name.udoc_name_title,
        udoc_name.udoc_name_keywords,
        udoc_name.udoc_name_descriptions,
        udoc_name.udoc_name_sort ".
        "FROM udoc LEFT JOIN udoc_name ON udoc.udoc_id=udoc_name.udoc_id ".
        "WHERE udoc.category_id=".$id." AND udoc.udoc_visible=1 ".$lang_where.$sort);
       
        if ($res->RecordCount()>0)
        {
            while ($element = $res->FetchArray())
            {
                $mass_element["udoc_id"][]=$element["udoc_id"];
                $mass_element["udoc_name"][]=$element["udoc_name"];

                if (($element["udoc_date"]!="0000-00-00") AND ($element["udoc_date"]!=""))
                {
                    $mass_element["udoc_date"][]=date('d.m.Y', $this->str2time($element["udoc_date"], 'Y-m-d'));
                    $mass_element["udoc_day"][]=date('d', $this->str2time($element["udoc_date"], 'Y-m-d'));
                    $mass_element["udoc_moon"][]=date('m', $this->str2time($element["udoc_date"], 'Y-m-d'));
                    $mass_element["udoc_year"][]=date('Y', $this->str2time($element["udoc_date"], 'Y-m-d'));
                }
                else
                {
                    $mass_element["udoc_date"][]=null;
                    $mass_element["udoc_day"][]=null;
                    $mass_element["udoc_moon"][]=null;
                    $mass_element["udoc_year"][]=null;
                }

                $mass_element["udoc_status"][]=$element["udoc_status"];
                $mass_element["udoc_picture_icon"][]=$element["udoc_picture_icon"];
                $mass_element["udoc_picture_banner"][]=$element["udoc_picture_banner"];
                $mass_element["udoc_name_id"][]=$element["udoc_name_id"];
                $mass_element["udoc_name_name"][]=$element["udoc_name_name"];
                $mass_element["udoc_name_description"][]=$element["udoc_name_description"];
                $mass_element["udoc_name_picture"][]=$element["udoc_name_picture"];
                $mass_element["udoc_name_title"][]=$element["udoc_name_title"];
                $mass_element["udoc_name_keywords"][]=$element["udoc_name_keywords"];
                $mass_element["udoc_name_descriptions"][]=$element["udoc_name_descriptions"];
                $mass_element["udoc_name_sort"][]=$element["udoc_name_sort"];
            }
        }

        return $mass_element;
    }

    //   
    function getUdocNamePage($udoc_name_id)
    {
        if ($udoc_name_id<=0) return 0;

        $mass_element=array();
        $res = $this->db->Execute("SELECT
        udoc_name.udoc_name_id,
        udoc_name.udoc_name_name,
        udoc_name.udoc_name_description,
        udoc_name.udoc_name_picture,
        udoc_name.udoc_name_title,
        udoc_name.udoc_name_keywords,
        udoc_name.udoc_name_descriptions,
        udoc_name.udoc_name_sort,
        udoc_name_page.udoc_name_page_id,
        udoc_name_page.udoc_name_page_name,
        udoc_name_page.udoc_name_page_description ".
        "FROM udoc_name LEFT JOIN udoc_name_page ON udoc_name.udoc_name_id=udoc_name_page.udoc_name_id ".
        "WHERE udoc_name.udoc_name_id=".$udoc_name_id." ORDER BY udoc_name_page.udoc_name_page_sort");

        if ($res->RecordCount()>0)
        {
            while ($element = $res->FetchArray())
            {
                $mass_element["udoc_name_id"][]=$element["udoc_name_id"];
                $mass_element["udoc_name_name"][]=$element["udoc_name_name"];
                $mass_element["udoc_name_description"][]=$element["udoc_name_description"];
                $mass_element["udoc_name_picture"][]=$element["udoc_name_picture"];
                $mass_element["udoc_name_title"][]=$element["udoc_name_title"];
                $mass_element["udoc_name_keywords"][]=$element["udoc_name_keywords"];
                $mass_element["udoc_name_descriptions"][]=$element["udoc_name_descriptions"];
                $mass_element["udoc_name_sort"][]=$element["udoc_name_sort"];
                $mass_element["udoc_name_page_id"][]=$element["udoc_name_page_id"];
                $mass_element["udoc_name_page_name"][]=$element["udoc_name_page_name"];
                $mass_element["udoc_name_page_description"][]=$element["udoc_name_page_description"];
            }
        }

        return $mass_element;
    }

    //   
    function getUdocNameFile($udoc_name_id)
    {
        if ($udoc_name_id<=0) return 0;

        $mass_element=array();
        $res = $this->db->Execute("SELECT * FROM udoc_name_file ".
        "WHERE udoc_name_id=".$udoc_name_id." ORDER BY udoc_name_file_sort");

        if ($res->RecordCount()>0)
        {
            while ($element = $res->FetchArray())
            {
                $mass_element["udoc_name_file_id"][]=$element["udoc_name_file_id"];
                $mass_element["udoc_name_file_name"][]=$element["udoc_name_file_name"];
                $mass_element["udoc_name_file_description"][]=$element["udoc_name_file_description"];
                $mass_element["udoc_name_file_picture"][]=$element["udoc_name_file_picture"];
                $mass_element["udoc_name_file_filename"][]=$element["udoc_name_file_filename"];
            }
        }

        return $mass_element;
    }

    // 
    function getUdocPicture($id, $lang=null)
    {
        if ($id<=0) return 0;

        //   
        $lang_where="";
        if ($lang!=null)
        {
        	$lang_where="AND (udoc_picture_name.lang_id=".$lang." OR udoc_picture_name.lang_id=0)";
        }
        else
        {
        	if ($this->lang_id > 0) $lang_where="AND (udoc_picture_name.lang_id=".$this->lang_id." OR udoc_picture_name.lang_id=0)";
        }

        $mass_element=array();
        $res = $this->db->Execute("SELECT
        udoc_picture.udoc_picture_id,
        udoc_picture.udoc_picture_name,
        udoc_picture.udoc_picture_picture,
        udoc_picture.udoc_picture_group_id,
        udoc_picture_name.udoc_picture_name_name,
        udoc_picture_name.udoc_picture_name_picture,
        udoc_picture_name.udoc_picture_name_description ".
        "FROM udoc_picture LEFT JOIN udoc_picture_name ON udoc_picture.udoc_picture_id=udoc_picture_name.udoc_picture_id ".
        "WHERE udoc_picture.udoc_id=".$id." ".$lang_where." ORDER BY udoc_picture.udoc_picture_sort");

        if ($res->RecordCount()>0)
        {
            while ($element = $res->FetchArray())
            {
                $mass_element["udoc_picture_id"][]=$element["udoc_picture_id"];
                $mass_element["udoc_picture_name"][]=$element["udoc_picture_name"];
                $mass_element["udoc_picture_picture"][]=$element["udoc_picture_picture"];
                $mass_element["udoc_picture_group_id"][]=$element["udoc_picture_group_id"];
                $mass_element["udoc_picture_name_name"][]=$element["udoc_picture_name_name"];
                $mass_element["udoc_picture_name_picture"][]=$element["udoc_picture_name_picture"];
                $mass_element["udoc_picture_name_description"][]=$element["udoc_picture_name_description"];
            }
        }

        return $mass_element;
    }


    //   
    function str2time($strStr, $strPattern = null)
    {
       $arrCharacters = array(
           'd', // day
           'm', // month
           'y', // year, 2 digits
           'Y', // year, 4 digits
           'H', // hours
           'i', // minutes
           's'  // seconds
       );
       $strCharacters = implode('', $arrCharacters);
       $arrDelimiters = preg_split('~['.$strCharacters.']~', $strPattern);
       $strDelimiters = quotemeta(implode('', array_unique($arrDelimiters)));
       $arrStr    = preg_split('~['.$strDelimiters.']~', $strStr);
       $arrPattern = preg_split('~['.$strDelimiters.']~', $strPattern);

       if (count($arrStr) !== count($arrPattern)) {
           return false;
       }

       $arrTime = array();
       for ($i = 0;$i < count($arrStr);$i++) {
           $arrTime[$arrPattern[$i]] = $arrStr[$i];
       }

       if (isset($arrTime['y']) && !isset($arrTime['Y'])) {
           $arrTime['Y'] = substr(date('Y'), 0, 2) . $arrTime['y'];
       }

       foreach ($arrCharacters as $strCharacter) {
           if (empty($arrTime[$strCharacter])) {
               $arrTime[$strCharacter] = date($strCharacter);
           }
       }

       if (!checkdate($arrTime['m'], $arrTime['d'], $arrTime['Y'])) {
           return false;
       }

       $intTime = mktime($arrTime['H'], $arrTime['i'], $arrTime['s'], $arrTime['m'], $arrTime['d'], $arrTime['Y']);

       return $intTime;
    }


    function RecordCount()
    {
        return $this->res->RecordCount();
    }

    function FetchArray()
    {
        return $this->res->FetchArray();
    }
}
?>
